from _decimal import Decimal
from pyson.JsonValue import JsonValue
from geniusweb.issuevalue.Value import Value


class NumberValue (Value):
	'''
	A value containing a number, that should be in some {@link NumberValueSet}.
	immutable
	'''

	def __init__(self, value:Decimal):
		if not isinstance(value, Decimal):
			raise ValueError("NumberValue must be Decimal, but got "+str(value)+ " of type "+str(type(value)))
		self._value = value

	@JsonValue()
	def getValue(self)->Decimal :
		return self._value;

	
	def __repr__(self): 
		return str(self._value)
	
	def __eq__(self, other):
		return isinstance(other, self.__class__) and  self._value == other._value

